Subject: Re: [PATCH] drivers/net/usb/asix: resync from vendor's copy

From: Mark Lord <[email-masked]>
Date: Wed, 09 Nov 2011 12:20:03 -0500

On 11-11-09 11:57 AM, Mark Lord wrote:
> On 11-11-09 11:47 AM, Mark Lord wrote:
> ..
>> Note:  I'm looking at smsc95xx.c and smsc75xx.c for examples,
>> and they both have the same problem I'll have here:
>>
>> How to update the csum settings atomically.
>> A spinlock is no good, because config register access is over USB.
> 
> Nevermind.. a slight change in the logic and all is well again.
..

Or even simpler (below).  I don't think this method requires any
extra locking, but I'm still open to persuasion.  :)

static int ax88772b_set_features(struct net_device *netdev, u32 features)
{
        struct usbnet *dev = netdev_priv(netdev);
        struct ax88772b_data *priv = (struct ax88772b_data *)dev->driver_priv;
        u16 tx_csum = 0, rx_csum = 0;

        priv->features = features & (NETIF_F_HW_CSUM | NETIF_F_RXCSUM);
        if (features & NETIF_F_HW_CSUM)
                tx_csum = AX_TXCOE_DEF_CSUM;
        if (features & NETIF_F_RXCSUM)
                rx_csum = AX_RXCOE_DEF_CSUM;
        ax8817x_write_cmd(dev, AX_CMD_WRITE_RXCOE_CTL, rx_csum, 0, 0, NULL);
        ax8817x_write_cmd(dev, AX_CMD_WRITE_TXCOE_CTL, tx_csum, 0, 0, NULL);
        return 0;
}